#ifndef CONFIG_H
#define CONFIG_H

/* how long between mouse-position checks, in msec */
#define INTERVAL 20

/* time in ms at which to invalidate a stroke */
/* (actually technically a bit imprecise, but close enough) */
#define TIMEOUT_INITIAL 200
#define TIMEOUT_RETURN 200

/* number of intervals which are allowed to have no mouse motion before */
/* invalidating */
#define SLOWNESS_GRACE 1

/* how much sloppiness is allowed in movement? */
#define DIRECTIONAL_RATIO 3

/* minimum distance (in pixels) the mouse must travel for a stroke to be valid */
#define DISTANCE_INITIAL 80
#define DISTANCE_RETURN 80


/* it's more convenient to use XSentEvent, because that lets you move the */
/* mouse off of the window and still send it keystrokes -- no such luck with */
/* XTestFakeKeyEvent. But FakeKeyEvent is more secure and therefore works with */
/* more apps. */
#define USEXTEST

#endif /* CONFIG_H */
