#include <stdlib.h>
#include <stdio.h> /* FIX -- remove after done testing */

#include "config.h"
#include "flicklogic.h"

#define NOSTROKE 0
#define INITIALSTROKE 1
#define RETURNSTROKE 2

int flicklogic(int mx, int my, int mb)
{
 	static int gesture_state=NOSTROKE;
 	static int direction=NOACTION;

	static int ox=-1;
 	static int oy=-1;
	static int sx=-1;
 	static int sy=-1;
 	
	static int tickcounter=0;
	static int grace_count=0;

	/*
	if ((mx!=ox) || (my!=oy))
	{
		printf("%d,%d %d -- %d\n",mx,my,mb,gesture_state);
	}
	*/
	
	switch (gesture_state)
	{
		case NOSTROKE:
			if (!mb && (abs(my-oy)<abs(mx-ox)/DIRECTIONAL_RATIO))
			{
				if (mx<ox)
				{
					direction=LEFTRIGHT;
				}
				else /* mx can never = ox, because then my-oy would be bigger */
				{
					direction=RIGHTLEFT;
				}					
					
				gesture_state=INITIALSTROKE;
				sx=mx;
				sy=my;
				tickcounter=0;
			}
		break;
		case INITIALSTROKE:
			if (mb)
			{
				printf("I mousedown\n");
				gesture_state=NOSTROKE;
			}
			else if (tickcounter>(TIMEOUT_INITIAL/INTERVAL))
			{ 
				printf("I timeout\n");
				gesture_state=NOSTROKE;
			}
			else if (mx==ox && my==oy)
			{
				grace_count++; 
				if (grace_count>SLOWNESS_GRACE)
				{
					printf("I tooslow\n");
					gesture_state=NOSTROKE;
				}
			}
			else if (abs(my-sy)>abs(mx-sx)/DIRECTIONAL_RATIO)
			{
				printf("I offcourse\n");
				gesture_state=NOSTROKE;
			}
			else if ((direction==LEFTRIGHT && mx>ox) || (direction==RIGHTLEFT && mx<ox))
			{
				if (abs(sx-ox)<DISTANCE_INITIAL)
				{
					printf("I tooshort\n");
					gesture_state=NOSTROKE;
				}
				else
				{
					gesture_state=RETURNSTROKE;
					sx=mx;
					sy=my;
					tickcounter=0;
				}
			}
			else
			{
				tickcounter++;
			}
		break;
		case RETURNSTROKE:
			if (mb)
			{ 
				printf("R mousedown\n");
				gesture_state=NOSTROKE;
			}
			else if (tickcounter>(TIMEOUT_RETURN/INTERVAL))
			{ 
				printf("R timeout\n");
				gesture_state=NOSTROKE;
			}
			else if (abs(my-sy)>abs(mx-sx)/DIRECTIONAL_RATIO) 
			{ 
				printf("R offcourse\n");
				gesture_state=NOSTROKE;
			}
			else if ((direction==LEFTRIGHT && mx<ox) || (direction==RIGHTLEFT && mx>ox))
			{
				printf("R wrongway\n");
				gesture_state=NOSTROKE;
			}
			else if (mx==ox && my==oy)
			{
				if (abs(mx-sx)<DISTANCE_RETURN)
				{
					printf("R tooshort\n");
					gesture_state=NOSTROKE;
				}
				else
				{
					/* Success! */
					gesture_state=NOSTROKE;
					return direction;
				}
			}
			else
			{
				ox=mx; oy=my;
				tickcounter++;
			}
		break;
	}		


	ox=mx;
	oy=my;
	grace_count=0;

	
	return NOACTION;
}
