#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <X11/Xlib.h>
#include <X11/keysym.h>

#include "config.h"
#include "flicklogic.h"
#include "sendkey.h"

Display* display;

void hello()
{
	if ((display=XOpenDisplay(NULL)) == NULL)
	{
		fprintf(stderr,"Can't open display. Sorry.\n");
		exit(1);
	}
}

void goodbye()
{
	XCloseDisplay(display);	
}


int main(int argc, char** argv)
{
	Window root_ret, child_ret;
	int root_x, root_y, child_x, child_y;
	int mouse_mask; 

	int action;
	
	hello();
	atexit(goodbye);

	while(1)  /* should do something less lame than (1).... */
	{
		XQueryPointer(display,DefaultRootWindow(display),&root_ret,&child_ret,&root_x,&root_y,&child_x,&child_y,&mouse_mask);

		/* the long confusing bit at the end of this line just exists to send only mouse buttons, not keyboard modifiers */
		action=flicklogic(root_x, root_y,mouse_mask & (Button1Mask|Button2Mask|Button3Mask|Button4Mask|Button5Mask)); 

		switch(action)
		{
			case NOACTION:
			break;
			case LEFTRIGHT:
				sendkey(display,XK_Left,Mod1Mask);
				printf("A LEFTRIGHT\a\n");
			break;
			case RIGHTLEFT:
				sendkey(display,XK_Right,Mod1Mask);
				printf("A RIGHTLEFT\a\n");
			break;
			case UPDOWN:
				printf("A UPDOWN\a\n");
			break;
			case DOWNUP:
				printf("A DOWNUP\a\n");
			break;
		}
		
		usleep(INTERVAL*1000);
	}

	return 0;
}
