#include <X11/Xlib.h>
#include <X11/extensions/XTest.h>
#include <X11/keysym.h>

#include "config.h"
#include "sendkey.h"

int sendkey(Display* disp, unsigned int keysym, unsigned int modifiers)
{
	XKeyEvent event;

#ifdef USEXTEST
	
	static int haveXtest=-1;	
	int testev,testma,testmi,tester;
	KeyCode keycode, modkeycode;
	
	if (haveXtest==-1)
	{
		if (XTestQueryExtension(disp,&testev,&tester,&testma,&testmi))
		{
			haveXtest=1;	
		}
		else
		{
			haveXtest=0;
		}
	}

	if (haveXtest==1)
	{
		keycode=XKeysymToKeycode(disp, keysym);
		/* FIX -- this only supports one mod key at a time. */
		if (modifiers & Mod1Mask)
		{
			modkeycode=XKeysymToKeycode(disp, XK_Alt_L);
		}
		else if (modifiers & ShiftMask)
		{
			modkeycode=XKeysymToKeycode(disp, XK_Shift_L);
		}
		else if (modifiers & ControlMask)
		{
			modkeycode=XKeysymToKeycode(disp, XK_Control_L);
		}
		else
		{
			modkeycode=NoSymbol;
		}
		
		
		
		if (modkeycode!=NoSymbol) XTestFakeKeyEvent(disp,modkeycode,True,0);
		XTestFakeKeyEvent(disp,keycode,True,0);
		XFlush(disp);
		if (modkeycode!=NoSymbol) XTestFakeKeyEvent(disp,modkeycode,False,0);
		XTestFakeKeyEvent(disp,keycode,False,0);
		XFlush(disp);
	}
	else
	{
#endif /* USEXTEST */	
		event.display = disp;
		event.window = InputFocus;
		event.root = DefaultRootWindow(disp);
		event.subwindow = None;
		event.time = CurrentTime;
		event.x=1; event.y=1; event.x_root=1; event.y_root=1;
		event.same_screen = True;
		event.type = KeyPress;
	
		event.keycode=XKeysymToKeycode(disp, keysym);
		event.state=modifiers;
		
		XSendEvent(event.display,event.window, True, KeyPressMask, (XEvent *)&event);

#ifdef USEXTEST
	}
#endif /* USEXTEST */	

	return 0; /* FIX - um, it might be nice to return something *useful* */
}
